uniform mat4 uVertexMatrix;
attribute vec4 aVertexCo;
attribute vec4 aTextureCo;

// 高斯算子左右偏移值，当偏移值为2时，高斯算子为5 x 5
const int SHIFT_SIZE = 14;

const float texelWidthOffset = 0.00138;
const float texelHeightOffset = 0.;

varying vec2 vTextureCo;
varying vec4 blurShiftCoordinates[SHIFT_SIZE];

void main() {
    gl_Position = uVertexMatrix * aVertexCo;
    vTextureCo = aTextureCo.xy;
    // 偏移步距
    vec2 singleStepOffset = vec2(texelWidthOffset, texelHeightOffset);
    // 记录偏移坐标
    for (int i = 0; i < SHIFT_SIZE; i++) {
        blurShiftCoordinates[i] = vec4(vTextureCo.xy - float(i + 1) * singleStepOffset,
        vTextureCo.xy + float(i + 1) * singleStepOffset);
    }
}