precision mediump float;

uniform sampler2D vTexture;
varying vec2 vTextureCo;
uniform float uRandom0;
uniform float uRandom1;

void main(){
    vec4 tex1 = texture2D(vTexture, vTextureCo + vec2(uRandom0, uRandom1*0.35));
    vec4 tex2 = texture2D(vTexture, vTextureCo + vec2(-uRandom0*1.4, uRandom1*0.5))*0.8;
    vec4 tex3 = texture2D(vTexture, vTextureCo + vec2(uRandom1*1.2, -uRandom0*0.3))*0.8;

    vec3 result;
    result.r = tex1.r * tex1.a;
    result.g = tex1.g * tex1.a + tex2.g * tex2.a;
    result.b = tex1.b * tex1.a + tex3.b * tex3.a;

    gl_FragColor=vec4(result, 1.0) * (tex1.a + tex2.a + tex3.a);
}