#extension GL_OES_EGL_image_external : require
precision mediump float;
varying highp vec2 vTextureCo;
uniform samplerExternalOES vTexture;
const lowp int GAUSSIAN_SAMPLES = 9;
const int SHIFT_SIZE = 14;

varying vec4 blurShiftCoordinates[SHIFT_SIZE];

void main() {
    // 计算当前坐标的颜色值
    vec4 currentColor = texture2D(vTexture, vTextureCo);
    mediump vec3 sum = currentColor.rgb;
    // 计算偏移坐标的颜色值总和
    for (int i = 0; i < SHIFT_SIZE; i++) {
        sum += texture2D(vTexture, blurShiftCoordinates[i].xy).rgb;
        sum += texture2D(vTexture, blurShiftCoordinates[i].zw).rgb;
    }
    // 求出平均值
    gl_FragColor = vec4(sum * 1.0 / float(2 * SHIFT_SIZE + 1), currentColor.a);
}