precision highp float;
#extension GL_OES_EGL_image_external : require

varying highp vec2 vTextureCo;
uniform samplerExternalOES vTexture;

const lowp mat4 colorMatrix = mat4(0.3588, 0.7044, 0.1368, 0.0,
0.2990, 0.5870, 0.1140, 0.0,
0.2392, 0.4696, 0.0912, 0.0,
0.0, 0.0, 0.0, 1.0);

const lowp float intensity = 1.0;

void main()
{
    lowp vec4 textureColor = texture2D(vTexture, vTextureCo);
    lowp vec4 outputColor = textureColor * colorMatrix;

    gl_FragColor = (intensity * outputColor) + ((1.0 - intensity) * textureColor);
}