// notation: js file can only use this kind of comments
// since comments will cause error when use in webview.loadurl,
// comments will be remove by java use regexp
  console.log('vipAccount and vipAccountBridge init begin');
  if (!window.vipAccount || !window.vipAccountBridge || !window.vipAccountBridge.callJavaHandler || !window.vipAccountBridge.callJavaResponse) {
    console.log('native must inject vipAccount and vipAccountBridge object first');
    return;
  }

  if (window.vipAccount.isInit) {
    console.log('vipAccountBridge has init');
    window.vipAccount.callHandler('default','init');
    return;
  }

  if(window.needWaitHandlerRegister){
     window.needWaitHandlerRegister=[...window.needWaitHandlerRegister,'onWebVisible'];
  }else{
     window.needWaitHandlerRegister=['onWebVisible']
  }
  var messageHandlers = {};
  var responseCallbacks = {};
  var uniqueId = 1;
  var waitMessageQueue={};

  // java call js Handler
  window.vipAccountBridge._handleMessageFromNative = function(messageJSON) {
    console.log(messageJSON);
    var message = JSON.parse(messageJSON);
    var responseCallback;
    // java call finished, now need to call js callback function
    if (message.responseId) {
      responseCallback = responseCallbacks[message.responseId];
      if (!responseCallback) {
        return;
      }
      responseCallback(message.responseData);
      delete responseCallbacks[message.responseId];
    } else {
      // 直接发送
      if (message.callbackId) {
        var callbackResponseId = message.callbackId;
        responseCallback = function(responseData) {
          window.vipAccountBridge.callJavaResponse(responseData, callbackResponseId);
          delete responseCallbacks[callbackResponseId];
        };
        responseCallbacks[callbackResponseId] = responseCallback;
      }

      var handler = null;
      if (message.handlerName) {
          handler = messageHandlers[message.handlerName];
      }
      if (!handler) {
        if(message.handlerName&&window.needWaitHandlerRegister&&window.needWaitHandlerRegister.indexOf(message.handlerName)>=0){
             waitMessageQueue[message.handlerName]={data:message.data,responseCallback:responseCallback};
             console.log('vipAccountBridge: wait for  handler:'+message.handlerName);
        }else{
         if (responseCallback && typeof responseCallback === 'function') {
                  responseCallback({ status: -1, data: 'no handler' });
           }
           console.log('vipAccountBridge: no handler');
        }

      } else {
        handler(message.data, responseCallback);
      }
    }
  };

    // js call java  handler
   window.vipAccount.callHandler = function(handlerName, data, responseCallback) {
    var callbackId = '';
    if (responseCallback) {
      if (typeof responseCallback === 'string') {
        callbackId = responseCallback;
      } else if (typeof responseCallback === 'function') {
        callbackId = 'cb_' + (uniqueId++) + '_' + new Date().getTime();
        responseCallbacks[callbackId] = responseCallback;
      }
    }
    window.vipAccountBridge.callJavaHandler(handlerName, JSON.stringify(data), callbackId);
  };


  // 注册handler 往数组里面添加值
  window.vipAccount.registerHandler = function(handlerName, handler) {
    console.log("js registerHandler:"+handlerName);
    messageHandlers[handlerName] = handler;
    var waitMessage=waitMessageQueue[handlerName];
    if(waitMessage){
         console.log("callhandler while register becuase has wait msg:"+handlerName+":data="+waitMessage.data+",callback="+waitMessage.responseCallback);
         handler(waitMessage.data,waitMessage.responseCallback);
         delete waitMessageQueue[handlerName];
    }
  };
  window.vipAccount.unRegisterHandler = function(handlerName) {
  console.log("js unRegisterHandler:"+handlerName);
    if (messageHandlers[handlerName]) {
      delete messageHandlers[handlerName];
    }
    var waitMessage=waitMessageQueue[handlerName];
        if(waitMessage){
             delete waitMessageQueue[handlerName];
        }
  };

   window.vipAccountBridge.createAPI = function(funcName) {
      return function(data, callBackFun) {
        window.vipAccount.callHandler(funcName, data, callBackFun);
      };
    };




